<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>FARMWISE IOT PLATFORM</title>
    <!-- Add the TensorFlow.js library -->
           <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/boxicons@latest/css/boxicons.min.css">
        <!--=============== CSS ===============-->
        <link rel="stylesheet" href="assets/css/styles.css">
        <!--=============== Julie CSS ===============-->
        <title>FARMWISE IOT PLATFORM</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
      <!-- Add the font-awesome stylesheet to the head of your HTML -->
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
      <script src="https://cdn.jsdelivr.net/npm/@tensorflow/tfjs"></script>
    <script src="https://cdn.jsdelivr.net/npm/@tensorflow/tfjs"></script>
    <!-- ... Your other head elements ... -->
</head>
<body>

        <header class="header" id="header">
        <nav class="nav container">
        <a href="#" class="nav__logo">FarmWise</a>
        <div class="nav__menu" id="nav-menu">
        <ul class="nav__list">
            <li class="nav__item">
                <a href="index.html" class="nav__link active-link">
                    <i class='bx bx-home-alt nav__icon'></i>
                    <span class="nav__name">Home</span>
                </a>
            </li>
            
            <li class="nav__item">
                <a href="controls.html" class="nav__link">
                    <i class='bx bx-user nav__icon'></i>
                    <span class="nav__name">Controls</span>
                </a>
            </li>

            <li class="nav__item">
                 <a href="predictions.html" class="nav__link">
                    <i class='bx bx-book-alt nav__icon'></i>
                    <span class="nav__name">Predictions</span>
                </a>
            </li>
          <li class="nav__item">
                 <a href="rover.html" class="nav__link">
                    <i class='bx bx-book-alt nav__icon'></i>
                    <span class="nav__name">Rover</span>
                </a>
            </li>
            <li class="nav__item">
                <a href="controls.html" class="nav__link">
                    <i class='bx bx-message-square-detail nav__icon'></i>
                    <span class="nav__name">Control Pump</span>
                </a>
            </li>
        </ul>
        </div>
        <img src="assets/img/perfil.png" alt="" class="nav__img">
        </nav>
        </header>
    <!-- ... Your existing HTML body ... -->
<main>
    <section class="container section section__height" id="home">
    <div class="container2">
        <div id="pestdetection">
    <h1>Upload Image for Prediction</h1>
    <form id="imageForm" enctype="multipart/form-data" method="POST" action="http://localhost:5000/predict">
        <input type="file" name="image" accept="image/*">
        <button type="submit">Predict</button>
    </form>

    <div id="predictionResult">
        <!-- Prediction result will be displayed here -->
    </div>

    <div id="imageDisplay">
        <!-- Image will be displayed here -->
    </div>

    <script>
        // Handle form submission
        const form = document.getElementById('imageForm');
        form.addEventListener('submit', async (event) => {
            event.preventDefault(); // Prevent default form submission
            const formData = new FormData(form); // Get form data
            try {
                const response = await fetch('http://localhost:5000/predict', {
                    method: 'POST',
                    body: formData
                });
                if (!response.ok) {
                    throw new Error('Prediction failed');
                }
                const result = await response.json(); // Parse JSON response
                displayPredictionResult(result); // Display prediction result
            } catch (error) {
                console.error('Error:', error);
            }
        });

        // Function to display prediction result
        function displayPredictionResult(result) {
            const predictionDiv = document.getElementById('predictionResult');
            predictionDiv.innerHTML = `
                <h2>Prediction Result:</h2>
                <p>Predicted Class: ${result.predicted_class}</p>
                <p>Prediction: ${JSON.stringify(result.prediction)}</p>
            `;

            // Display the uploaded image
            const imageDisplayDiv = document.getElementById('imageDisplay');
            const imageElement = document.createElement('img');
            imageElement.src = URL.createObjectURL(form.elements.image.files[0]);
            imageElement.width = 300;
            imageElement.height = 200;
            imageDisplayDiv.innerHTML = ''; // Clear previous image
            imageDisplayDiv.appendChild(imageElement);
        }
    </script>
        </div>
        
            <!-- Add Tips and Suggestions button, checklist, submit button, and suggestion section -->
            <div class="tips-section">
            <button class="tips-button" onclick="getTips()">Tips and Suggestions</button>
            <div id="tips-checkboxes" class="tips-checklist">
            <input type="checkbox" id="plants" value="plants">
            <label for="plants">Plants to Grow Now</label><br>

            <input type="checkbox" id="crop-rotation" value="crop-rotation">
            <label for="crop-rotation">Crop Rotation</label><br>

            <input type="checkbox" id="companion-planting" value="companion-planting">
            <label for="companion-planting">Companion Planting</label><br>

            <input type="checkbox" id="pest-control" value="pest-control">
            <label for="pest-control">Natural Pest Control</label><br>

            <input type="checkbox" id="soil-improvement" value="soil-improvement">
            <label for="soil-improvement">Soil Improvement Techniques</label><br>

            <input type="checkbox" id="irrigation-tips" value="irrigation-tips">
            <label for="irrigation-tips">Efficient Irrigation Tips</label><br>

            <input type="checkbox" id="seasonal-care" value="seasonal-care">
            <label for="seasonal-care">Seasonal Plant Care Guidelines</label><br>

            <input type="checkbox" id="plant-lifecycle-1" value="plant-lifecycle-1">
            <label for="plant-lifecycle-1">Plant Lifecycle - Option 1</label><br>

            <input type="checkbox" id="plant-lifecycle-2" value="plant-lifecycle-2">
            <label for="plant-lifecycle-2">Plant Lifecycle - Option 2</label><br>
            <!-- Add more checkboxes for plant-specific options as needed -->
            </div>

            <!-- Add submit button -->
            <button class="submit-button" onclick="submitTips()">Submit</button>

            <!-- Suggestions section -->
            <div id="suggestions-section">
            <p>
            Plants to Grow Now:<br>
            - Eggplants thrive in warm climates, so ensure a sunny location for optimal growth.<br>
            - Choose well-draining soil enriched with compost.<br><br>

            Crop Rotation:<br>
            - Rotate eggplant crops annually to prevent soil-borne diseases.<br>
            - Avoid planting eggplants where tomatoes, peppers, or potatoes grew the previous year.<br><br>

            Companion Planting:<br>
            - Plant eggplants near basil to enhance flavor and deter pests.<br>
            - Marigolds and nasturtiums also make excellent companions for eggplants.<br><br>

            Natural Pest Control:<br>
            - Introduce beneficial insects like ladybugs and predatory beetles to control pests.<br>
            - Neem oil or garlic spray can help deter common eggplant pests.<br><br>
            </p>
            <!-- Suggestions will be dynamically injected here -->
            </div>
            </div>
    </div>
    </main>

<script>
    let model;
    let classLabels;

    // Function to load the TensorFlow.js model
    async function loadModel() {
        // Specify the correct relative path to your TensorFlow.js model directory (model/model5custom in this case)
        const modelPath = 'model/model5custom';
        //const modelPath = 'model/pest';
        model = await tf.loadLayersModel(`${modelPath}/model.json`);
        console.log('TensorFlow.js model loaded:', model);

        // Load class labels dynamically from the JSON file
        classLabels = await loadClassLabels();
        console.log('Class labels loaded:', classLabels);
    }

    // Function to load class labels from the JSON file
    async function loadClassLabels() {
        const response = await fetch('model/model5custom/inverted_class_indices.json');
        const labelsData = await response.json();
        return Object.values(labelsData);
    }

    // Function to preprocess the image
    async function preprocessImage(image) {
        const tensor = tf.browser.fromPixels(image).resizeNearestNeighbor([224, 224]).toFloat();
        const offset = tf.scalar(127.5);
        return tensor.sub(offset).div(offset).expandDims();
    }

    // Function to make predictions
    async function predict() {
        const fileInput = document.getElementById('fileInput');
        const file = fileInput.files[0];

        const img = new Image();
        img.src = URL.createObjectURL(file);
        img.onload = async function () {
            if (!model) {
                await loadModel();
            }

            const tensor = await preprocessImage(img);
            const prediction = model.predict(tensor);
            const result = Array.from(prediction.dataSync());
            const classIndex = result.indexOf(Math.max(...result));

            // Display result
            const resultDisplay = document.getElementById('response');
            resultDisplay.textContent = `Predicted class: ${classLabels[classIndex]}`;
        };

        const preview = document.getElementById('preview');
        preview.src = URL.createObjectURL(file);
    }
</script>
</body>
</html>
